import { Text } from "@codemirror/state";
import { CompletionContext, CompletionResult } from "@codemirror/autocomplete";
import { SyntaxNode } from "@lezer/common";
export interface TagSpec {
    attrs?: Record<string, null | readonly string[]>;
    globalAttrs?: boolean;
    children?: readonly string[];
}
export declare const eventAttributes: string[];
export declare class Schema {
    tags: Record<string, TagSpec>;
    globalAttrs: Record<string, null | readonly string[]>;
    allTags: readonly string[];
    globalAttrNames: readonly string[];
    constructor(extraTags?: Record<string, TagSpec>, extraAttrs?: Record<string, null | readonly string[]>);
    static default: Schema;
}
export declare function elementName(doc: Text, tree: SyntaxNode | null | undefined, max?: number): string;
export declare function htmlCompletionSource(context: CompletionContext): CompletionResult;
export declare function htmlCompletionSourceWith(config: {
    extraTags?: Record<string, TagSpec>;
    extraGlobalAttributes?: Record<string, null | readonly string[]>;
}): (context: CompletionContext) => CompletionResult;
