import { Parser } from "@lezer/common";
import { LRLanguage, LanguageSupport } from "@codemirror/language";
import { TagSpec } from "./complete";
export { htmlCompletionSource, TagSpec, htmlCompletionSourceWith } from "./complete";
declare type NestedLang = {
    tag: string;
    attrs?: (attrs: {
        [attr: string]: string;
    }) => boolean;
    parser: Parser;
};
declare type NestedAttr = {
    name: string;
    tagName?: string;
    parser: Parser;
};
export declare const htmlPlain: LRLanguage;
export declare const htmlLanguage: LRLanguage;
export declare function html(config?: {
    matchClosingTags?: boolean;
    selfClosingTags?: boolean;
    autoCloseTags?: boolean;
    extraTags?: Record<string, TagSpec>;
    extraGlobalAttributes?: Record<string, null | readonly string[]>;
    nestedLanguages?: NestedLang[];
    nestedAttributes?: NestedAttr[];
}): LanguageSupport;
export declare const autoCloseTags: import("@codemirror/state").Extension;
